package javaExt;

import java.util.Iterator;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.openarchitectureware.workflow.WorkflowInterruptedException;

public class Utility {
	public static void log(Object o) {
		System.out.println(o != null ? o.toString() : "<null>");
	}
	
	public static void error(String msg, String function, String file) {
		WorkflowInterruptedException e = new WorkflowInterruptedException("error:"+msg+ "(function:" +function+" in "+file + ")");
		throw e;
	}
	
	public static Boolean validateModel(EObject object) {
		Diagnostic diagnostic = Diagnostician.INSTANCE.validate(object);
		if (diagnostic.getSeverity() == Diagnostic.ERROR || diagnostic.getSeverity() == Diagnostic.WARNING) {
			System.out.println(diagnostic.getMessage());
			for (Iterator<Diagnostic> i = diagnostic.getChildren().iterator(); i.hasNext();) {
				Diagnostic childDiagnostic = i.next();
				switch (childDiagnostic.getSeverity()) {
					case Diagnostic.ERROR:
					case Diagnostic.WARNING:
						System.out.println("\t" + childDiagnostic.getMessage());
				}
			}
			return false;
		}
		return true;
	}
}
